import 'package:example/state/state.dart';
import 'package:osam/domain/store/store.dart';
import 'package:osam/osam.dart';
import 'package:osam/presentation/presenter.dart';
import 'package:osam/util/state_stream.dart';

import 'custon_event.dart';

class ExamplePresenter extends Presenter<Store<AppState>> {
  String get initialData => store.state.counter;

  StateStream<String> get stream => store.state.propertyStream((state) {
        return state.counter;
      });

  void increment() => store.dispatchEvent(event: IncrementEvent());
}
