import 'package:osam/domain/event/event.dart';
import 'package:osam/domain/state/base_state.dart';
import 'package:osam/domain/store/store.dart';

typedef bool Condition<ST extends BaseState<ST>>(Event<ST> event);

abstract class Middleware<ST extends BaseState<ST>> {
  Store<ST> store;

  bool nextEvent(bool next) => next;
  List<Condition<ST>> get conditions;

  @override
  bool operator ==(Object other) => runtimeType == other.runtimeType;

  @override
  int get hashCode => runtimeType.hashCode;
}
