import 'package:osam/domain/state/base_state.dart';

// ignore: must_be_immutable
class StateWithNavigation<T> extends BaseState<StateWithNavigation<T>> {
  final T _initialRoute;
  var routes = <T>[];

  StateWithNavigation(this._initialRoute) {
    routes.add(_initialRoute);
  }

  void push(T route) => routes.add(route);

  void pushReplacement(T route) => routes..replaceRange(routes.length - 1, routes.length, [route]);

  void pop() => routes.removeLast();

  @override
  List<T> get props => [...routes];
}

// ignore: must_be_immutable
class TabNavigationState<T> extends BaseState<TabNavigationState> {
  final T _initialTab;

  T currentTab;

  TabNavigationState(this._initialTab) {
    currentTab = _initialTab;
  }

  @override
  List<T> get props => [currentTab];
}
