import 'package:flutter/cupertino.dart';

import 'navigation_presenter_interface.dart';

class OsamWillPopScope extends StatelessWidget {
  final INavigation presenter;
  final Widget child;

  const OsamWillPopScope({Key key, this.presenter, this.child}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return WillPopScope(
      key: ValueKey(key.toString() + 'wps'),
      child: child,
      onWillPop: () async {
        if (presenter.routeStream.initialData.length > 1) {
          presenter.pop();
          return false;
        } else {
          return true;
        }
      },
    );
  }
}
